﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Tennis
{
  public partial class TennisForm : Form
  {

    // Increment the x-coordinate of the ballLocation by this
    // much every 10 milliseconds
    private float ballHorizontalVelocity = .447f;

    public TennisForm()
    {
      InitializeComponent();
      BackColor = Color.DarkGreen;
      Width = 780;
      Height = 360;
      DoubleBuffered = true;

      Timer timer_ = new Timer();
      timer_.Interval = 10;
      timer_.Tick += Timer__Tick;
      timer_.Start();

      MouseClick += Form1_MouseClick;

      ResizeRedraw = true;
      Paint += Form1_Paint;
    }

    private void Form1_MouseClick(object sender, MouseEventArgs e)
    {
      Graphics graphics = CreateGraphics();
      // TODO: When the mouse is clicked in the left-side of
      // the court, between the base line and the service line
      // create a ball at the clicked location.  The ball will have
      // a horizontal velocity of ballHorizontalVeloicty 
      // in world coordinates.
    }

    private void Timer__Tick(object sender, EventArgs e)
    {
      // TODO:  if a ball exists, advance it by ballHorizontalVelocity
      // and cause the ball to be drawn at its new location.
    }

    void setRightHalfWorldCoordinates(Graphics graphics)
    {
      // Set the world coordinates so that the left side of
      // the tennis court will be drawn with world coordinate (0,0) at the
      // top-left corner of the court.  The court should have a 10% margin
      // on all sides.
    }

    void setLeftHalfWorldCoordinates(Graphics graphics)
    {
      // Set the world coordinates so that the right side of
      // the tennis court will be drawn with world coordinate (0,0) at the
      // top-right corner of the court.  Reverse the x-axis so that the x 
      // increases as you move left.  The court should have a 10% margin
      // on all sides.
    }

  
    private void Form1_Paint(object sender, PaintEventArgs e)
    {
      setLeftHalfWorldCoordinates(e.Graphics);
      // TODO: uncomment the following line after you
      // write setLeftHalfWorldCoordinates
      //drawHalfCourt(e.Graphics);

      e.Graphics.ResetTransform();
      setRightHalfWorldCoordinates(e.Graphics);
      // TODO: uncomment the following line after you
      // write setRightHalfWorldCoordinates
      //drawHalfCourt(e.Graphics);

      e.Graphics.ResetTransform();
    }

    private void drawHalfCourt(Graphics graphics)
    {
      Pen linePen = new Pen(Brushes.White, 0);

      // Draw the horizontal lines from the baseline to the net.

      // Draw the top sidelines
      graphics.DrawLine(linePen, 0, 0, 18 + 21, 0);
      graphics.DrawLine(linePen, 0, 4.5f, 18 + 21, 4.5f);

      // Draw the center lines
      graphics.DrawLine(linePen, 0, 4.5f + 13.5f, 4.0f, 4.5f + 13.5f);
      graphics.DrawLine(linePen, 18, 4.5f + 13.5f, 18+21, 4.5f + 13.5f);

      // Draw the bottom sidelines
      graphics.DrawLine(linePen, 0, 4.5f + 13.5f + 13.5f, 18+21, 4.5f + 13.5f*2);
      graphics.DrawLine(linePen, 0, 4.5f + 13.5f + 13.5f + 4.5f, 18+21, 
        (4.5f +13.5f)*2);

      // Draw the vertical lines

      // Draw the Base Line
      graphics.DrawLine(linePen, 0, 0, 0, 4.5f + 13.5f + 13.5f + 4.5f);

      // Draw the Service Line
      graphics.DrawLine(linePen, 18, 0, 18, 4.5f + 13.5f + 13.5f + 4.5f);
    }
  }
}
